const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const events = sequelize.define(
    'events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title_text: {
        type: DataTypes.TEXT,
      
      

      },

description_text: {
        type: DataTypes.TEXT,
      
      

      },

visibility: {
        type: DataTypes.ENUM,
      
      

        values: [

"public",


"group_only",


"invite_only"

        ],

      },

location_text: {
        type: DataTypes.TEXT,
      
      

      },

online_url: {
        type: DataTypes.TEXT,
      
      

      },

starts_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

capacity: {
        type: DataTypes.INTEGER,
      
      

      },

requires_ticket: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  events.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













    db.events.hasMany(db.tickets, {
      as: 'tickets_event',
      foreignKey: {
          name: 'eventId',
      },
      constraints: false,
    });


    db.events.hasMany(db.notifications, {
      as: 'notifications_event',
      foreignKey: {
          name: 'eventId',
      },
      constraints: false,
    });








    db.events.hasMany(db.transactions, {
      as: 'transactions_event',
      foreignKey: {
          name: 'eventId',
      },
      constraints: false,
    });







//end loop



    db.events.belongsTo(db.users, {
      as: 'host',
      foreignKey: {
        name: 'hostId',
      },
      constraints: false,
    });

    db.events.belongsTo(db.groups, {
      as: 'group',
      foreignKey: {
        name: 'groupId',
      },
      constraints: false,
    });




    db.events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return events;
};


